﻿using Microsoft.Win32;
using Syncfusion.DocIO.DLS;
using Syncfusion.Windows.Controls.RichTextBoxAdv;
using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="T:Sample.MainWindow">MainWindow</see> class. 
        /// </summary>
        /// <remarks></remarks>
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Called when mouse dropped on RichTextBoxAdv.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">An <see cref="T:System.Windows.DragEventArgs">DragEventArgs</see> that contains the event data.</param>
        /// <remarks></remarks>
        private void RichTextBoxAdv_PreviewDrop(object sender, DragEventArgs e)
        {
            richTextBoxAdv.CaptureMouse();

            // Raises mouse event to perform selection at mouse point.

            MouseButtonEventArgs downEvent = new MouseButtonEventArgs(Mouse.PrimaryDevice, Environment.TickCount, MouseButton.Left);
            downEvent.RoutedEvent = Mouse.MouseDownEvent;
            richTextBoxAdv.RaiseEvent(downEvent);

            MouseButtonEventArgs upEvent = new MouseButtonEventArgs(Mouse.PrimaryDevice, Environment.TickCount, MouseButton.Left);
            upEvent.RoutedEvent = Mouse.MouseUpEvent;
            richTextBoxAdv.RaiseEvent(upEvent);

            // Handle your code here.. 
            // Example inserting text on selection point..
            richTextBoxAdv.Selection.InsertText("<------ Text here ------>");
            
            richTextBoxAdv.ReleaseMouseCapture();
        }

        /// <summary>
        /// Called when window unloaded.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">An <see cref="T:System.Windows.RoutedEventArgs">RoutedEventArgs</see> that contains the event data.</param>
        /// <remarks></remarks>
        private void Window_Unloaded(object sender, RoutedEventArgs e)
        {
            richTextBoxAdv.PreviewDrop -= RichTextBoxAdv_PreviewDrop;
            richTextBoxAdv.Dispose();
            Unloaded -= Window_Unloaded;
        }
    }
}
